aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorYaroslav de la Peña Smirnov <yps@yaroslavps.com>2023-02-05 20:38:06 +0300
committerYaroslav de la Peña Smirnov <yps@yaroslavps.com>2023-02-05 20:38:06 +0300
commit7fbfd4a8c77277da3847e712af86616b17602e27 (patch)
tree1b6884ff847921f7749d5005385efa1ff2ebcc75
downloadboobs-7fbfd4a8c77277da3847e712af86616b17602e27.tar.gz
boobs-7fbfd4a8c77277da3847e712af86616b17602e27.zip
init
-rw-r--r--README.md5
-rwxr-xr-xboobs.sh265
2 files changed, 270 insertions, 0 deletions
diff --git a/README.md b/README.md
new file mode 100644
index 0000000..0169e8f
--- /dev/null
+++ b/README.md
@@ -0,0 +1,5 @@
+# BOOBS: Base OS and Options Bootstrapping Script
+
+Taken from [LARBS](https://larbs.xyz/) and modified to suit my needs.
+
+TODO: proper description.
diff --git a/boobs.sh b/boobs.sh
new file mode 100755
index 0000000..d19b90a
--- /dev/null
+++ b/boobs.sh
@@ -0,0 +1,265 @@
+#!/bin/sh
+
+# BOOBS: Base OS and Options Bootstrapping Script
+# Yaroslav de la Peña Smirnov <yps@yaroslavps.com>
+# based on Luke's Auto Rice Boostrapping Script (LARBS)
+# by Luke Smith <luke@lukesmith.xyz>
+# License: GNU GPLv3
+
+### OPTIONS AND VARIABLES ###
+
+dotfilesrepo="https://git.yaroslavps.com/configs/swayrice"
+progsfile=""
+aurhelper="yay"
+
+
+### FUNCTIONS ###
+
+installpkg() {
+ pacman --noconfirm --needed -S "$1" >/dev/null 2>&1
+}
+
+error() {
+ # Log to stderr and exit with failure.
+ printf "%s\n" "$1" >&2
+ exit 1
+}
+
+welcomemsg() {
+ whiptail --title "Welcome!" \
+ --msgbox "Welcome to the Base OS and Options Bootstrapping Script!\\n\\nThis script will automatically install a fully-featured Linux desktop, which I use as my main machine.\\n\\n-Luke" 10 60
+
+ whiptail --title "Important Note!" --yes-button "All ready!" \
+ --no-button "Return..." \
+ --yesno "Be sure the computer you are using has current pacman updates and refreshed Arch keyrings.\\n\\nIf it does not, the installation of some programs might fail." 8 70
+}
+
+getuserandpass() {
+ # Prompts user for new username an password.
+ name=$(whiptail --inputbox "First, please enter a name for the user account." 10 60 3>&1 1>&2 2>&3 3>&1) || exit 1
+ while ! echo "$name" | grep -q "^[a-z_][a-z0-9_-]*$"; do
+ name=$(whiptail --nocancel --inputbox "Username not valid. Give a username beginning with a letter, with only lowercase letters, - or _." 10 60 3>&1 1>&2 2>&3 3>&1)
+ done
+ pass1=$(whiptail --nocancel --passwordbox "Enter a password for that user." 10 60 3>&1 1>&2 2>&3 3>&1)
+ pass2=$(whiptail --nocancel --passwordbox "Retype password." 10 60 3>&1 1>&2 2>&3 3>&1)
+ while ! [ "$pass1" = "$pass2" ]; do
+ unset pass2
+ pass1=$(whiptail --nocancel --passwordbox "Passwords do not match.\\n\\nEnter password again." 10 60 3>&1 1>&2 2>&3 3>&1)
+ pass2=$(whiptail --nocancel --passwordbox "Retype password." 10 60 3>&1 1>&2 2>&3 3>&1)
+ done
+}
+
+usercheck() {
+ ! { id -u "$name" >/dev/null 2>&1; } ||
+ whiptail --title "WARNING" --yes-button "CONTINUE" \
+ --no-button "No wait..." \
+ --yesno "The user \`$name\` already exists on this system. BOOBS can install for a user already existing, but it will OVERWRITE any conflicting settings/dotfiles on the user account.\\n\\nBOOBS will NOT overwrite your user files, documents, videos, etc., so don't worry about that, but only click <CONTINUE> if you don't mind your settings being overwritten.\\n\\nNote also that BOOBS will change $name's password to the one you just gave." 14 70
+}
+
+preinstallmsg() {
+ whiptail --title "Let's get this party started!" --yes-button "Let's go!" \
+ --no-button "No, nevermind!" \
+ --yesno "The rest of the installation will now be totally automated, so you can sit back and relax.\\n\\nIt will take some time, but when done, you can relax even more with your complete system.\\n\\nNow just press <Let's go!> and the system will begin installation!" 13 60 || {
+ clear
+ exit 1
+ }
+}
+
+adduserandpass() {
+ # Adds user `$name` with password $pass1.
+ whiptail --infobox "Adding user \"$name\"..." 7 50
+ useradd -m -s /bin/zsh "$name"
+ export repodir="/home/$name/src"
+ export pkgbuildsdir="/home/$name/src/pkgbuilds"
+ export dotsdir="/home/$name/src/personal"
+ mkdir -p "$repodir/pkgbuilds"
+ mkdir -p "$repodir/personal"
+ chown -R "$name":"$name" "$(dirname "$repodir")"
+ echo "$name:$pass1" | chpasswd
+ unset pass1 pass2
+}
+
+refreshkeys() {
+ case "$(readlink -f /sbin/init)" in
+ *systemd*)
+ whiptail --infobox "Refreshing Arch Keyring..." 7 40
+ pacman --noconfirm -S archlinux-keyring >/dev/null 2>&1
+ ;;
+ *)
+ whiptail --infobox "Enabling Arch Repositories for more a more extensive software collection..." 7 40
+ if ! grep -q "^\[universe\]" /etc/pacman.conf; then
+ echo "[universe]
+Server = https://universe.artixlinux.org/\$arch
+Server = https://mirror1.artixlinux.org/universe/\$arch
+Server = https://mirror.pascalpuffke.de/artix-universe/\$arch
+Server = https://artixlinux.qontinuum.space/artixlinux/universe/os/\$arch
+Server = https://mirror1.cl.netactuate.com/artix/universe/\$arch
+Server = https://ftp.crifo.org/artix-universe/" >>/etc/pacman.conf
+ pacman -Sy --noconfirm >/dev/null 2>&1
+ fi
+ pacman --noconfirm --needed -S \
+ artix-keyring artix-archlinux-support >/dev/null 2>&1
+ for repo in extra community; do
+ grep -q "^\[$repo\]" /etc/pacman.conf ||
+ echo "[$repo]
+Include = /etc/pacman.d/mirrorlist-arch" >>/etc/pacman.conf
+ done
+ pacman -Sy >/dev/null 2>&1
+ pacman-key --populate archlinux >/dev/null 2>&1
+ ;;
+ esac
+}
+
+pkgbuildinstall() {
+ # Installs manually with makepkg -si by cloning
+ # Should be run after repodir is created and var is set.
+ progname="${1##*/}"
+ progname="${progname%.git}"
+ pacman -Qq "$progname" && return 0
+ whiptail --infobox "Installing \"$progname\" manually with makepkg." 7 50
+ sudo -u "$name" git -C "$pkgbuildsdir" clone -q \
+ "$1" ||
+ {
+ cd "$pkgbuildsdir/$progname" || return 1
+ sudo -u "$name" git pull --force origin master
+ }
+ cd "$pkgbuildsdir/$progname" || exit 1
+ sudo -u "$name" -D "$pkgbuildsdir/$progname" \
+ makepkg --noconfirm -si >/dev/null 2>&1 || return 1
+}
+
+maininstall() {
+ # Installs all needed programs from main repo.
+ whiptail --title "BOOBS Installation" --infobox "Installing \`$1\` ($n of $total). $1 $2" 9 70
+ installpkg "$1"
+}
+
+gitmakeinstall() {
+ progname="${1##*/}"
+ progname="${progname%.git}"
+ dir="$repodir/$progname"
+ whiptail --title "BOOBS Installation" \
+ --infobox "Installing \`$progname\` ($n of $total) via \`git\` and \`make\`. $(basename "$1") $2" 8 70
+ sudo -u "$name" git -C "$repodir" clone --depth 1 --single-branch \
+ --no-tags -q "$1" "$dir" ||
+ {
+ cd "$dir" || return 1
+ sudo -u "$name" git pull --force origin master
+ }
+ cd "$dir" || exit 1
+ make >/dev/null 2>&1
+ make install >/dev/null 2>&1
+ cd /tmp || return 1
+}
+
+aurinstall() {
+ whiptail --title "BOOBS Installation" \
+ --infobox "Installing \`$1\` ($n of $total) from the AUR. $1 $2" 9 70
+ echo "$aurinstalled" | grep -q "^$1$" && return 1
+ sudo -u "$name" $aurhelper -S --noconfirm "$1" >/dev/null 2>&1
+}
+
+installationloop() {
+ ([ -f "$progsfile" ] && cp "$progsfile" /tmp/progs.csv) ||
+ curl -Ls "$progsfile" | sed '/^#/d' >/tmp/progs.csv
+ total=$(wc -l </tmp/progs.csv)
+ aurinstalled=$(pacman -Qqm)
+ while IFS=, read -r tag program comment; do
+ n=$((n + 1))
+ echo "$comment" | grep -q "^\".*\"$" &&
+ comment="$(echo "$comment" | sed -E "s/(^\"|\"$)//g")"
+ case "$tag" in
+ "A") aurinstall "$program" "$comment" ;;
+ "G") gitmakeinstall "$program" "$comment" ;;
+ "P") pkgbuildinstall "$program" "$comment" ;;
+ *) maininstall "$program" "$comment" ;;
+ esac
+ done </tmp/progs.csv
+}
+
+putdotfiles() {
+ # Downloads a gitrepo $1 and runs stow.sh script to install with GNU stow
+ whiptail --infobox "Downloading and installing config files..." 7 60
+ [ -z "$2" ] && branch="master" || branch="$repobranch"
+ confname="${1##*/}"
+ confname="${confname%.git}"
+ sudo -u "$name" git -C "$dotsdir" clone --recursive -b "$branch" \
+ --recurse-submodules "$1"
+ sudo -u "$name" "$dotsdir/$confname/stow.sh"
+}
+
+finalize() {
+ whiptail --title "All done!" \
+ --msgbox "Congrats! Provided there were no hidden errors, the script completed successfully and all the programs and configuration files should be in place.\\n\\nTo run the new graphical environment, log out and log back in as your new user, then run the command to start the graphical environment (e.g. \"sway\", unless you have it configed to start automatically in tty<N> as I do).\\n\\n.t Yaroslav" 13 80
+}
+
+### THE ACTUAL SCRIPT ###
+
+### This is how everything happens in an intuitive format and order.
+
+# Check if user is root on Arch distro. Install whiptail.
+pacman --noconfirm --needed -Sy libnewt ||
+ error "Are you sure you're running this as the root user, are on an Arch-based distribution and have an internet connection?"
+
+# Welcome user and pick dotfiles.
+welcomemsg || error "User exited."
+
+# Get and verify username and password.
+getuserandpass || error "User exited."
+
+# Give warning if user already exists.
+usercheck || error "User exited."
+
+# Last chance for user to back out before install.
+preinstallmsg || error "User exited."
+
+### The rest of the script requires no user input.
+
+# Refresh Arch keyrings.
+refreshkeys ||
+ error "Error automatically refreshing Arch keyring. Consider doing so manually."
+
+for x in curl ca-certificates base-devel git stow ntp zsh; do
+ whiptail --title "BOOBS Installation" \
+ --infobox "Installing \`$x\` which is required to install and configure other programs." 8 70
+ installpkg "$x"
+done
+
+whiptail --title "BOOBS Installation" \
+ --infobox "Synchronizing system time to ensure successful and secure installation of software..." 8 70
+ntpd -q -g >/dev/null 2>&1
+
+adduserandpass || error "Error adding username and/or password."
+
+[ -f /etc/sudoers.pacnew ] && cp /etc/sudoers.pacnew /etc/sudoers # Just in case
+
+# Allow user to run sudo without password. Since AUR programs must be installed
+# in a fakeroot environment, this is required for all builds with AUR.
+trap 'rm -f /etc/sudoers.d/boobs-temp' HUP INT QUIT TERM PWR EXIT
+echo "%wheel ALL=(ALL) NOPASSWD: ALL" >/etc/sudoers.d/boobs-temp
+
+# Make pacman colorful with Pacman eye-candy.
+grep -q "ILoveCandy" /etc/pacman.conf || sed -i "/#VerbosePkgLists/a ILoveCandy" /etc/pacman.conf
+#sed -Ei "s/^#(ParallelDownloads).*/\1 = 5/;/^#Color$/s/#//" /etc/pacman.conf
+
+# Use all cores for compilation.
+sed -i "s/-j2/-j$(nproc)/;/^#MAKEFLAGS/s/^#//" /etc/makepkg.conf
+
+# The command that does all the installing. Reads the progs.csv file and
+# installs each needed program the way required. Be sure to run this only after
+# the user has been created and has priviledges to run sudo without a password
+# and all build dependencies are installed.
+installationloop
+
+# Install the dotfiles in the user's home directory, but remove .git dir and
+# other unnecessary files.
+putdotfiles "$dotfilesrepo" "$repobranch"
+
+# Allow wheel users to sudo with password and allow several system commands
+# (like `shutdown` to run without password).
+echo "%wheel ALL=(ALL:ALL) ALL" >/etc/sudoers.d/00-boobs-wheel-can-sudo
+echo "%wheel ALL=(ALL:ALL) NOPASSWD: /usr/bin/pacman -Syu,/usr/bin/pacman -Syyu,/usr/bin/pacman -Syyu --noconfirm,/usr/bin/loadkeys,/usr/bin/pacman -Syyuw --noconfirm,/usr/bin/pacman -S -u -y --config /etc/pacman.conf --,/usr/bin/pacman -S -y -u --config /etc/pacman.conf --" >/etc/sudoers.d/01-boobs-cmds-without-password
+echo "Defaults editor=/usr/bin/nvim" >/etc/sudoers.d/02-boobs-visudo-editor
+
+# Last message! Install complete!
+finalize